"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const Strategy_1 = require("./Strategy");
const consts_1 = require("../consts");
let User = class User {
};
User = __decorate([
    Strategy_1.Strategy(consts_1.ExclusionPolicy.ALL)
], User);
function createClass() {
    let tmp = class tmp {
    };
    tmp = __decorate([
        Strategy_1.Strategy(consts_1.ExclusionPolicy.ALL),
        Strategy_1.Strategy(consts_1.ExclusionPolicy.ALL)
    ], tmp);
    /* istanbul ignore next */
    return tmp;
}
describe('Strategy', () => {
    it('should have exclusion strategy on object', () => {
        const user = new User();
        const strategy = Reflect.getMetadata(consts_1.StrategySymbol, user.constructor);
        chai_1.expect(strategy).to.equal(consts_1.ExclusionPolicy.ALL);
    });
    it('should not apply strategy decorator twice', () => {
        chai_1.expect(createClass).to.throw("Cannot apply @Strategy decorator twice on class 'tmp'.");
    });
});
//# sourceMappingURL=Strategy.spec.js.map