"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const Before_1 = require("./Before");
const consts_1 = require("../consts");
class Foo {
    constructor() {
        this.prop = 'prop';
        this.prop2 = 'prop2';
        this.prop3 = 'prop3';
    }
}
__decorate([
    Before_1.Before('1.2.0'),
    __metadata("design:type", Object)
], Foo.prototype, "prop", void 0);
__decorate([
    Before_1.Before('0.9.2'),
    __metadata("design:type", Object)
], Foo.prototype, "prop3", void 0);
function declareClass() {
    /* istanbul ignore next */
    class tmp {
        constructor() {
            this.prop3 = 'prop3';
        }
    }
    __decorate([
        Before_1.Before(''),
        Before_1.Before(''),
        __metadata("design:type", Object)
    ], tmp.prototype, "prop3", void 0);
    /* istanbul ignore next */
    return tmp;
}
describe('Before', () => {
    it('should add metadata to the object before list with the specific property', () => {
        const foo = new Foo();
        const metadata = Reflect.getMetadata(consts_1.BeforeSymbol, foo);
        chai_1.expect(metadata).to.deep.equal({
            prop: '1.2.0',
            prop3: '0.9.2',
        });
    });
    it('should not add metadata twice, it should throws an exception instead', () => {
        chai_1.expect(declareClass).to.throw("Cannot apply @Before decorator twice on property 'prop3' of class 'tmp'.");
    });
});
//# sourceMappingURL=Before.spec.js.map