"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const Expose_1 = require("../PropertiesDecorators/Expose");
const Serializer_1 = require("./Serializer");
const Groups_1 = require("../PropertiesDecorators/Groups");
const Before_1 = require("../PropertiesDecorators/Before");
const After_1 = require("../PropertiesDecorators/After");
const Name_1 = require("../PropertiesDecorators/Name");
const Strategy_1 = require("../ClassDecorators/Strategy");
const consts_1 = require("../consts");
const _1 = require("../");
const Serializer_2 = require("../PropertiesDecorators/Serializer");
class Foo {
    constructor() {
        this.prop = 'prop';
        this.prop2 = 'prop2';
        this.prop3 = 'prop3';
    }
}
__decorate([
    Before_1.Before('1.2.0'),
    Name_1.Name('foo'),
    __metadata("design:type", String)
], Foo.prototype, "prop", void 0);
__decorate([
    After_1.After('1.0.0'),
    __metadata("design:type", String)
], Foo.prototype, "prop2", void 0);
class Bar {
    constructor() {
        this.prop = 'prop';
        this.prop2 = 'prop2';
        this.prop3 = 'prop3';
    }
}
__decorate([
    Groups_1.Groups(['special']),
    Name_1.Name('bar'),
    __metadata("design:type", String)
], Bar.prototype, "prop", void 0);
class TwoLevels {
    constructor() {
        this.bar = new Bar();
        this.bar.prop = 'prop-changed';
    }
}
__decorate([
    Name_1.Name('barClass'),
    Groups_1.Groups(['special']),
    __metadata("design:type", Bar)
], TwoLevels.prototype, "bar", void 0);
class ThreeLevels {
    constructor() {
        this.twoLevels = new TwoLevels();
    }
}
__decorate([
    Expose_1.Expose(),
    Groups_1.Groups(['special']),
    __metadata("design:type", TwoLevels)
], ThreeLevels.prototype, "twoLevels", void 0);
class FourLevels {
    constructor() {
        this.threeLevels = new ThreeLevels();
    }
}
__decorate([
    Expose_1.Expose(),
    Groups_1.Groups(['special']),
    __metadata("design:type", ThreeLevels)
], FourLevels.prototype, "threeLevels", void 0);
let User = class User {
    constructor() {
        this.firstName = 'Dan';
        this.lastName = 'Revah';
        this.username = 'danrevah';
        this.password = '123456';
    }
};
__decorate([
    Expose_1.Expose(),
    Groups_1.Groups(['personal']),
    __metadata("design:type", String)
], User.prototype, "firstName", void 0);
__decorate([
    Expose_1.Expose(),
    Groups_1.Groups(['personal']),
    __metadata("design:type", String)
], User.prototype, "lastName", void 0);
__decorate([
    Expose_1.Expose(),
    __metadata("design:type", String)
], User.prototype, "username", void 0);
User = __decorate([
    Strategy_1.Strategy(consts_1.ExclusionPolicy.ALL)
], User);
let DynamicFoo = class DynamicFoo {
    constructor() {
        this.prop = 'prop';
        this.prop2 = 'prop2';
        this.prop3 = 'prop3';
    }
};
__decorate([
    Expose_1.Expose((obj, key) => key === 'prop'),
    __metadata("design:type", String)
], DynamicFoo.prototype, "prop", void 0);
__decorate([
    Expose_1.Expose(() => false),
    __metadata("design:type", String)
], DynamicFoo.prototype, "prop2", void 0);
DynamicFoo = __decorate([
    Strategy_1.Strategy(consts_1.ExclusionPolicy.ALL)
], DynamicFoo);
class DynamicNoneFoo {
    constructor() {
        this.prop = 'prop';
        this.prop2 = 'prop2';
        this.prop3 = 'prop3';
    }
}
__decorate([
    _1.Exclude(() => true),
    __metadata("design:type", String)
], DynamicNoneFoo.prototype, "prop", void 0);
__decorate([
    _1.Exclude(() => false),
    __metadata("design:type", String)
], DynamicNoneFoo.prototype, "prop2", void 0);
class TwoLevelsArray {
    constructor() {
        this.bar = [new Bar(), new Bar()];
    }
}
__decorate([
    Name_1.Name('barClass'),
    Groups_1.Groups(['special']),
    __metadata("design:type", Array)
], TwoLevelsArray.prototype, "bar", void 0);
class CircularReferenceSingleClass {
    constructor() {
        this.name = 'circular';
    }
}
class CircularReferenceArrClass {
    constructor() {
        this.name = 'circular';
    }
}
class SerializerTest {
    constructor() {
        this.name = 'test';
    }
}
__decorate([
    Serializer_2.Serializer((value) => 'foo-' + value),
    __metadata("design:type", String)
], SerializerTest.prototype, "name", void 0);
describe('Serializer', () => {
    it('should expose properties while serializing', () => {
        const foo = new Foo();
        chai_1.expect(Serializer_1.serialize(foo)).to.equal('{"foo":"prop","prop2":"prop2","prop3":"prop3"}');
    });
    it('should expose properties while serializing array', () => {
        const fooArr = [new Foo(), new Foo()];
        chai_1.expect(Serializer_1.serialize(fooArr)).to.equal('[{"foo":"prop","prop2":"prop2","prop3":"prop3"},{"foo":"prop","prop2":"prop2","prop3":"prop3"}]');
    });
    it('should expose properties while serializing with version', () => {
        const foo = new Foo();
        chai_1.expect(Serializer_1.serialize(foo, [], '1.1.0')).to.equal('{"foo":"prop","prop2":"prop2","prop3":"prop3"}');
        chai_1.expect(Serializer_1.serialize(foo, [], '1.3.0')).to.equal('{"prop2":"prop2","prop3":"prop3"}');
        chai_1.expect(Serializer_1.serialize(foo, [], '0.9.0')).to.equal('{"foo":"prop","prop3":"prop3"}');
    });
    it('should expose properties while serializing class with functions', () => {
        const bar = new Bar();
        chai_1.expect(Serializer_1.serialize(bar)).to.equal('{"bar":"prop","prop2":"prop2","prop3":"prop3"}');
    });
    it('should expose properties while serializing class with group', () => {
        const bar = new Bar();
        chai_1.expect(Serializer_1.serialize(bar, ['special'])).to.equal('{"bar":"prop"}');
    });
    it('should not expose properties while serializing class with group who does not exist', () => {
        const bar = new Bar();
        chai_1.expect(Serializer_1.serialize(bar, ['other'])).to.equal('{}');
    });
    it('should expose properties while serializing class with two level hierarchy', () => {
        const twoLevels = new TwoLevels();
        chai_1.expect(Serializer_1.serialize(twoLevels)).to.equal('{"barClass":{"bar":"prop-changed","prop2":"prop2","prop3":"prop3"}}');
    });
    it('should expose properties while serializing class with three level hierarchy', () => {
        const threeLevels = new ThreeLevels();
        chai_1.expect(Serializer_1.serialize(threeLevels)).to.equal('{"twoLevels":{"barClass":{"bar":"prop-changed","prop2":"prop2","prop3":"prop3"}}}');
    });
    it('should expose properties while serializing class with three level hierarchy', () => {
        const fourLevels = new FourLevels();
        chai_1.expect(Serializer_1.serialize(fourLevels)).to.equal('{"threeLevels":{"twoLevels":{"barClass":{"bar":"prop-changed","prop2":"prop2","prop3":"prop3"}}}}');
    });
    it('should expose properties while serializing class with three level hierarchy and group', () => {
        const fourLevels = new FourLevels();
        chai_1.expect(Serializer_1.serialize(fourLevels, ['special'])).to.equal('{"threeLevels":{"twoLevels":{"barClass":{"bar":"prop-changed"}}}}');
    });
    it('should expose only exposed properties while exclusion policy is set to ALL', () => {
        const user = new User();
        chai_1.expect(Serializer_1.serialize(user)).to.equal('{"firstName":"Dan","lastName":"Revah","username":"danrevah"}');
    });
    it('should expose only exposed properties while exclusion policy is set to ALL and show current group', () => {
        const user = new User();
        chai_1.expect(Serializer_1.serialize(user, ['personal'])).to.equal('{"firstName":"Dan","lastName":"Revah"}');
    });
    it('should expose properties while serializing with functions', () => {
        const foo = new DynamicFoo();
        chai_1.expect(Serializer_1.serialize(foo)).to.equal('{"prop":"prop"}');
    });
    it('should exclude properties while serializing with functions', () => {
        const foo = new DynamicNoneFoo();
        chai_1.expect(Serializer_1.serialize(foo)).to.equal('{"prop2":"prop2","prop3":"prop3"}');
    });
    it('should serialize arrays nested types', () => {
        const foo = new TwoLevelsArray();
        chai_1.expect(Serializer_1.serialize(foo)).to.equal('{"barClass":[{"bar":"prop","prop2":"prop2","prop3":"prop3"},{"bar":"prop","prop2":"prop2","prop3":"prop3"}]}');
        chai_1.expect(Serializer_1.serialize(foo, ['special'])).to.equal('{"barClass":[{"bar":"prop"},{"bar":"prop"}]}');
    });
    it('should ignore circular references', () => {
        const foo = new CircularReferenceSingleClass();
        foo.circular = foo;
        chai_1.expect(Serializer_1.serialize(foo)).to.equal('{"name":"circular"}');
    });
    it('should ignore circular references inside arrays', () => {
        const arr = new CircularReferenceArrClass();
        const foo = new CircularReferenceSingleClass();
        foo.circular = foo;
        arr.circular = [foo, foo, foo];
        chai_1.expect(Serializer_1.serialize(arr)).to.equal('{"name":"circular","circular":[{"name":"circular"},{"name":"circular"},{"name":"circular"}]}');
    });
    it('should use custom serializer if using @Serializer on property', () => {
        const test = new SerializerTest();
        chai_1.expect(Serializer_1.serialize(test)).to.equal('{"name":"foo-test"}');
    });
});
//# sourceMappingURL=Serializer.spec.js.map