"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
require("reflect-metadata");
require("mocha");
const helpers_1 = require("./helpers");
describe('Helpers', () => {
    it('should check isUndefined', () => {
        let foo;
        chai_1.expect(helpers_1.isUndefined(1)).to.be.false;
        chai_1.expect(helpers_1.isUndefined(undefined)).to.be.true;
        chai_1.expect(helpers_1.isUndefined(foo)).to.be.true;
    });
    it('should check isObject', () => {
        chai_1.expect(helpers_1.isObject(null)).to.be.false;
        chai_1.expect(helpers_1.isObject({})).to.be.true;
        chai_1.expect(helpers_1.isObject([])).to.be.false;
        chai_1.expect(helpers_1.isObject(42)).to.be.false;
    });
    it('should check versionCompare', () => {
        chai_1.expect(helpers_1.versionCompare('2.1.0', '2.0.0')).to.equal(1);
        chai_1.expect(helpers_1.versionCompare('1.0.0', '2.0.0')).to.equal(-1);
        chai_1.expect(helpers_1.versionCompare('1.2.4', '1.2.5')).to.equal(-1);
        chai_1.expect(helpers_1.versionCompare('1.3.4', '1.4.5')).to.equal(-1);
        chai_1.expect(helpers_1.versionCompare('1.3.4', '1.3.4')).to.equal(0);
        chai_1.expect(helpers_1.versionCompare('1.0.0', 'foo')).to.be.NaN;
    });
});
//# sourceMappingURL=helpers.spec.js.map